export interface Execution<T> {
    run(): T;
    toString(): string;
}
export declare class SuccessExecution<T> implements Execution<T> {
    private readonly value;
    constructor(value: T);
    run(): T;
    toString(): string;
}
export declare class FailureExecution<T> implements Execution<T> {
    private readonly error;
    constructor(error: any);
    run(): T;
    toString(): string;
}
export declare class UnknownExecution implements Execution<unknown> {
    run(): unknown;
    toString(): string;
}
