"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnknownExecution = exports.FailureExecution = exports.SuccessExecution = void 0;
const interrupt_1 = require("./interrupt");
class SuccessExecution {
    constructor(value) {
        this.value = value;
    }
    run() {
        return this.value;
    }
    toString() {
        return typeof this.value;
    }
}
exports.SuccessExecution = SuccessExecution;
class FailureExecution {
    constructor(error) {
        this.error = error;
    }
    run() {
        throw this.error;
    }
    toString() {
        return `err(${this.error.constructor.name})`;
    }
}
exports.FailureExecution = FailureExecution;
class UnknownExecution {
    run() {
        throw new interrupt_1.ReexecuteInterrupt();
    }
    toString() {
        return '->';
    }
}
exports.UnknownExecution = UnknownExecution;
